//#pragma comment(linker, "/STACK:16777216")
#include <algorithm>
#include <bitset>
#include <cmath>
#include <ctime>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <deque>
#include <fstream>
#include <functional>
#include <iostream>
#include <map>
#include <set>
#include <sstream>
#include <stack>
#include <queue>
#include <vector>
#include <utility>
using namespace std;

string text,pattern;
int f[1000010];

void build(string pattern)
{
    f[0] = -1;
    for (int i = 1; i < pattern.size(); i++)
    {
        int j = f[i - 1];
        for (; ;)
        {
            if (pattern[i] == pattern[j + 1])
            {
                f[i] = j + 1;  break;
            }
            if (j < 0)
            {
                f[i] = -1;  break;
            }
            j = f[j];
        }        
    }
}

void KMP(string text)
{
    int i = 0,j = -1;
    for (; ;)
    {
        if (i == text.size()) return;
        if (text[i] == pattern[j + 1])
        {
            i++;  j++;
            if (j >= pattern.size() - 1)
            {
                printf("%d ", i + 1 - pattern.size());  j = f[j];
            }
        }
        else if (j >= 0) j = f[j];
        else i++;
    }
}

int main()
{
//  freopen("substr.in","r",stdin);
//  freopen("substr.ou","w",stdout);
    cin >> text >> pattern;
    build(pattern);
    KMP(text);
}
